Category: Estimated time: 0.00 hour
Target version:

Description
Realizzare pacchetto debian per octonet.

Non deve dipendere da octofussd, solo da pyoctofuss (pacchetto python3-octofuss)

Il pacchetto deve contere i locale compilati, e una volta installato deve avviare il servizio automaticamente tramite unit systemd, in
ascolto sulla porta 13402 (default vecchio, per cui i fw hanno gia' aperture)

Associated revisions

Revision aa95a2e5 - 12/06/2016 09:13 AM - Enrico Zini
Added setup.py and autogenerated debian/ from it. refs: #85

Revision d27722fb - 12/06/2016 10:25 AM - Enrico Zini
Use python3, added include filters for package data. refs: #85

Revision cf5adccc - 12/06/2016 10:25 AM - Enrico Zini
Package a python3 program instead of a python2 module. refs: #85

Revision 7efdca5c - 12/06/2016 01:23 PM - Enrico Zini

Updated message catalogs. refs: #85

Revision 34e847c5 - 12/06/2016 01:41 PM - Enrico Zini

Install locale files. refs: #85

Revision 937238dc - 12/07/2016 10:28 AM - Enrico Zini

New language catalogs. refs: #85

Revision 64000db2 - 12/07/2016 10:28 AM - Enrico Zini
Also package manage.py. refs: #85

Revision ca405131 - 12/07/2016 10:28 AM - Enrico Zini

Do not package local_settings.py. refs: #85

Revision 96¢73¢25 - 12/07/2016 10:28 AM - Enrico Zini

Manage /var/cache/octonet. refs: #85

Revision 6bbb795f - 12/07/2016 12:51 PM - Enrico Zini

Install systemd service to run octonet via gunicorn3. refs: #85

Revision d638d371 - 12/07/2016 01:37 PM - Enrico Zini

Updated unit file after /usr/share/doc/gunicorn-examples/examples/gunicorn-mysite.service. refs: #85
Revision e7ee27dc - 12/07/2016 02:08 PM - Enrico Zini

Package an initial apache configuration. refs: #85

Revision d62a0b3a - 12/07/2016 02:33 PM - Enrico Zini
Deploy with FORCE_SCRIPT_NAME to work in a sub-url. refs: #85

Revision a50a33c3 - 12/07/2016 02:49 PM - Enrico Zini

Use reverse_lazy, because reverse would be called too early to get things right. refs: #85

Revision aae1aa64 - 12/07/2016 02:49 PM - Enrico Zini

Collect static files and serve them via apache. refs: #85

Revision 5310f7e7 - 12/09/2016 04:42 PM - Enrico Zini

Use the right reverse function. refs: #85

Revision 3129ec97 - 12/09/2016 04:42 PM - Enrico Zini

Completely ignore all apache config if mod_proxy is not available. refs: #85

Revision 2c683cdc - 12/09/2016 04:42 PM - Enrico Zini

Assume it's running again at / instead of /octofuss. refs: #85

Revision 0ac1b805 - 12/12/2016 12:34 PM - Enrico Zini

Use Whitenoise to serve static files. refs: #85

Revision 74b3eba1l - 12/12/2016 12:54 PM - Enrico Zini

Do not ship apache configuration snippet. refs: #85

Revision d345b7cc - 12/12/2016 03:48 PM - Enrico Zini

Use /etc/octonet.conf as extra settings, and generate a secret key for it. refs: #85

Revision dd99dbc0 - 12/12/2016 03:58 PM - Enrico Zini
Added Debian packaging. Fixes #85

History

#1 - 11/24/2016 02:06 PM - Christopher R. Gabriel

Ricordarsi di esplicitare la dipendenza da python3-django >= 1.8, che viene da backports, altrimenti con la 1.7 standard di jessie ci sono problemi
(non compatibile)

#2 - 12/06/2016 09:04 AM - Enrico Zini

- Assignee set to Enrico Zini

#3 - 12/06/2016 09:08 AM - Enrico Zini

Documentazione di riferimento: https://wiki.debian.org/DjangoPackagingDraft

#4 - 12/06/2016 10:31 AM - Enrico Zini
Documentazione di riferimento:
¢ https://wiki.debian.org/DjangoPackagingDraft

¢ https://www.debian.org/doc/packaging-manuals/python-policy/ch-programs.html
e https://wiki.debian.org/Python/Pybuild
#5 - 12/06/2016 10:32 AM - Enrico Zini
Anche http://meetbot.debian.net/debian-women/2010/debian-women.2010-12-02-20.02.log.html dalla posizione 20:33:07

#6 - 12/06/2016 02:37 PM - Enrico Zini

- translation missing: en.field_checklist set to [ ] Packaging dei file in /usr/share/octonet, [ ] Gestione directory per la cache in /var/cache/octonet, [ |
Aggiunta configurazione per deploy apache+wsgi in /etc/apache2/sites-available, [ ] Attivazione configurazione di apache al momento dell'installazione

#7 - 12/06/2016 02:37 PM - Enrico Zini

- translation missing: en.field_checklist changed from [ ] Packaging dei file in /usr/share/octonet to [x] Packaging dei file in /usr/share/octonet

#8 - 12/07/2016 10:29 AM - Enrico Zini

- translation missing: en.field_checklist changed from [ | Gestione directory per la cache in /var/cache/octonet to [x] Gestione directory per la cache in
/var/cache/octonet

#9 - 12/07/2016 10:56 AM - Christopher R. Gabriel

Rileggendo anche la descrizione del ticket, mi ero dimenticato I'altro giorno dell'aspetto dei firewall: dobbiamo metterlo in ascolto su 13402, e poi
forniamo il pezzo per apache2/conf.d per il reverse proxy dal vhost 'octofuss'. Ma almeno e' accessibile da entrambi i canali.

Per il deploy, gunicorn3 funziona molto bene, e ha il suo supporto (gunicorn3-debian e relativa conf.d) per fornire snippet di configurazione per
I'avvio/stop del servizio

#10 - 12/07/2016 11:24 AM - Enrico Zini

Per riferimento: https://wiki.debian.org/Apache/PackagingFor24

#11 - 12/07/2016 12:28 PM - Enrico Zini

Christopher R. Gabriel, non trovo il pacchetto gunicorn3-debian. Mi puoi mandare uno snippet di configurazione d'esempio per lo start/stop di un
servizio django?

#12 - 12/07/2016 12:35 PM - Christopher R. Gabriel

- Status changed from Nuovo to Commenti

Scusa, gunicorn3-debian €' il comando per fare start/stop, €' contenuto nei pacchetti gunicorn3/python3-gunicorn.
Questo lo snippet che ho creato per l'installazione demo di octonet, che poi vorrei sostituire con quella fornita dal pacchetto:

natalia:~# cat /etc/gunicorn.d/octonet

CONFIG = {
'mode': 'wsgi',
'working_dir': '/var/lib/octofuss/octonet/"',
'python': '/usr/bin/python3',
'user': 'www-data',
'group': 'www-data',
'args': (

'--bind=127.0.0.1:8091",
'-—workers=4",
'octonet.wsgi',

) ’

05/17/2025 3/8
#13 - 12/07/2016 12:55 PM - Enrico Zini

Sull'attuale testing, nessuno di quei due pacchetti contiene gunicorn3-debian. L'ho cercato anche in packages.debian.org ma non trovo un pacchetto
che lo fornisca.

Intanto, in 6bbb795f ho aggiunto una unit di systemd per far partire il server via gunicorn3.

Hai uno snippet di apache pronto per fare il reverse proxy, da qualche altro progetto?

#14 - 12/07/2016 01:00 PM - Christopher R. Gabriel

Enrico Zini ha scritto:

Sull'attuale testing, nessuno di quei due pacchetti contiene gunicorn3-debian. L'ho cercato anche in packages.debian.org ma non trovo un
pacchetto che lo fornisca.

Ti rammento che 'attuale target e' stable, incluso backports:

cgabriel@filippone ~ $ apt-cache policy python3-debian gunicorn3
python3-debian:
Installed: 0.1.27
Candidate: 0.1.27
Version table:
DS @,1.27 ©
500 http://httpredir.debian.org/debian/ jessie/main amd64 Packages
100 /var/lib/dpkg/status
gunicorn3:
Installed: (none)
Candidate: 19.6.0-2~bpo8+1
Version table:
19.6.0-2~bpo8+1 0
100 http://httpredir.debian.org/debian/ jessie-backports/main amdé64 Packages

Intanto, in 6bbb795f ho aggiunto una unit di systemd per far partire il server via gunicorn3.

Hai uno snippet di apache pronto per fare il reverse proxy, da qualche altro progetto?

Da altri progetti no, te lo scrivo qui:

<Location /octofuss>
<Directory /var/lib/FIXME/DIR/WITH/CODE>
Options —-Indexes
AllowOverride None
Require all granted
</Directory>

Alias /static/ /var/lib/FIXME/PATH/TO/COLLECTED/STATIC
ProxyPass /static !

ProxyPass / http://127.0.0.1:13402/

ProxyPassReverse / http://127.0.0.1:13402/

ProxyPreserveHost On

</Location>

da testare poi, scritto a braccio. Lo snippet da piazzare direi in /etc/apache2/conf.d/
#15 - 12/07/2016 01:21 PM - Enrico Zini

https://packages.debian.org/search?searchon=contents&keywords=gunicorn3-debian&mode=exactfilename&suite=stable&arch=any
mi dice:
"You have searched for files named gunicorn3-debian in suite jessie, all sections, and all architectures. Sorry, your search gave no results"

Ad ogni modo, sembra basti systemd.

#16 - 12/07/2016 01:23 PM - Christopher R. Gabriel

Non so che dirti, guarda qua su stable:

natalia:~# dpkg -S gunicorn3-debian
gunicorn3: /usr/share/man/man8/gunicorn3-debian.8.gz
gunicorn3: /usr/sbin/gunicorn3-debian

natalia:~# apt-cache policy gunicorn3
gunicorn3:
Installed: 19.6.0-2~bpo8+1
Candidate: 19.6.0-2~bpo8+1
Version table:
***% 19.6.0-2~bpo8+1 0
100 http://httpredir.debian.org/debian/ jessie-backports/main 1386 Packages
100 /var/lib/dpkg/status
natalia:~#

Forse packages non cerca in backports?

#17 - 12/07/2016 01:38 PM - Enrico Zini

Confermo, al momento esiste solo in backports. |l nuovo gunicorn dice questo:

$ cat /usr/share/doc/gunicorn/README.Debian
README.Debian for gunicorn

The /etc/gunicorn.d (and related usr/sbin/gunicorn{,3}-debian) scripts were
removed in 19.6.0-3 due to inflexibility, lack of documentation, not
adopted/supported upstream, did not work with virtualenvs, etc.

They were dropped prior to the stretch release to avoid having to support it
for another full release.

Users relying on this feature should invoke gunicorn manually. For an example

systemd .service file, please see the "~ “gunicorn-mysite.service file in the
gunicorn-examples package or a process manager such as runit, etc.
—— Chris Lamb <lamby@debian.org> Thu, 06 Oct 2016 19:45:15 +0100

Quindi direi che possiamo stare sulla configurazione di systemd che ho gia fatto e funziona.

#18 - 12/07/2016 01:38 PM - Christopher R. Gabriel

Ottimo! Allora non vedo l'ora di poterla usare cosi' elimino gunicorn3-debian :D

#19 - 12/07/2016 02:15 PM - Enrico Zini

In e7ee27dc ho aggiunto una configurazione iniziale per apache. Ha due problemi:

1. se il modulo proxy_http non € attivo, non parte. Non ho trovato ancora un modo per far attivare il modulo mod_proxy_http all'installazione del
pacchetto. Lo aggiungo alla checklist.

2. django e fatto per girare come http://sito/ e non come http://sito/octonet/. Questo vuol dire che se al momento vado su http://localhost/octonet lui mi
ridirige su http://localhost/login/?next=http%3A//localhost/.

Per risolvere il secondo punto, la soluzione consigliata & fare un NameVirtualHost http://octonet.sito, pero significa che in fase di deploy c'é da
assicurarsi che il dominio risolva, e da chiedere il nome del dominio per metterlo nel file.

In alternativa, si cambia il root urlconf per avere tutto sempre sotto a /octonet. Procedo con questa seconda ipotesi?

#20 - 12/07/2016 02:16 PM - Enrico Zini

- translation missing: en.field_checklist changed from [x] Packaging dei file in /usr/share/octonet, [x] Gestione directory per la cache in
/var/cache/octonet, [ ] Aggiunta configurazione per deploy apache+wsgi in /etc/apache2/sites-available, [ ] Attivazione configurazione di apache al
momento dell'installazione to [x] Packaging dei file in /usr/share/octonet, [x] Gestione directory per la cache in /var/cache/octonet, [ ] Aggiunta
configurazione per deploy apache+wsgi in /etc/apacheZ2/sites-available, [ ] Attivazione configurazione di apache al momento dell'installazione, [ |
Attivare mod_proxy_http al momento dell'installazione

#21 - 12/07/2016 02:31 PM - Enrico Zini
Ho risolto il punto 2 con FORCE_SCRIPT_NAME: https://docs.djangoproject.com/en/1.8/ref/settings/#force-script-name

Cosi va da apache, ma genera URL sbagliati se uno visita direttamente http://localhost:13402/

Al momento non ho idea se sia possibile far andare entrambi

#22 - 12/07/2016 02:32 PM - Enrico Zini

...forse pastrugnando con un middleware? Bisogna vedere come django gestisce FORCE_SCRIPT_NAME, e se vale la pena lavorare per far andare
entrambi i casi.
#23 - 12/07/2016 02:50 PM - Enrico Zini

- translation missing: en.field_checklist changed from [ ] Aggiunta configurazione per deploy apache+wsgi in /etc/apache2/sites-available to [x]
Aggiunta configurazione per deploy apache+wsgi in /etc/apache2/sites-available

#24 - 12/07/2016 02:50 PM - Enrico Zini

- translation missing: en.field_checklist changed from [ ] Attivazione configurazione di apache al momento dell'installazione to [x] Attivazione
configurazione di apache al momento dell'installazione

#25 - 12/07/2016 02:50 PM - Enrico Zini

Ora gestisce anche gli static file. Manca solo attivare mod_proxy e mod_proxy_http a tempo di installazione.

#26 - 12/08/2016 05:40 PM - Enrico Zini

Riguardo a mod_proxy, ho cercato un po' e ho trovato questo:

enrico> codehelp: I'm studying lava-server's debian/ dir because I have a similar case at hand (django website
to be packaged deployed with gunicorn3 and mod_proxy). How do you make sure mod_proxy and mod_proxy_http are
loaded by apache?

enrico> codehelp: (if you do)

codehelp> enrico: not part of the packaging - it's a documented installation step

enrico> codehelp: ack, thanks

"A documented installation step” conflitta con la richiesta di avere octonet che & installato e va.

Vuoi che aggiunga una domanda di debconf "attivo mod_proxy?" con default a no, che poi uno lo mette a si coi preseeding, o anche quello & un
passo in pil che crea fastidio?

In alternativa, chiamo a2enmod proxy_http in postinst, e il pacchetto avra il side effect che se lo installo e lo purgio, mi ritrovo con mod_proxy attivo in
apache.

#27 - 12/08/2016 05:58 PM - Enrico Zini

- translation missing: en.field_checklist changed from [x] Packaging dei file in /usr/share/octonet, [x] Gestione directory per la cache in
/var/cache/octonet, [x] Aggiunta configurazione per deploy apache+wsgi in /etc/apache2/sites-available, [x] Attivazione configurazione di apache al
momento dell'installazione, [ ] Attivare mod_proxy_htto al momento dell'installazione to [x] Packaging dei file in /usr/share/octonet, [x] Gestione
directory per la cache in /var/cache/octonet, [x] Aggiunta configurazione per deploy apache+wsgi in /etc/apache2/sites-available, [x] Attivazione
configurazione di apache al momento dell'installazione, [ ] Attivare mod_proxy_http al momento dell'installazione, [ ] Far servire i file statici a gunicorn3

Consenso dopo telefonata: il pacchetto si occupa di tirar su tutto che giri correttamente con gunicorn, e aggiunge una configurazione opzionale per
apache che lo serve via mod_proxy_http con il rewrite degli url
#28 - 12/09/2016 04:41 PM - Enrico Zini

gunicorn non supporta il servire file statici, e Django in teoria nemmeno a meno di non fare una porcheria:
http://stackoverflow.com/questions/12800862/how-to-make-django-serve-static-files-with-gunicorn

In alternativa si pud dipendere da WhiteNoise (http://whitenoise.evans.io/en/stable/), che perd non c'é in jessie.

#29 - 12/12/2016 10:56 AM - Christopher R. Gabriel

Farli servire a django direttamente, aggiungendo

from django.contrib.staticfiles.urls import staticfiles_urlpatterns
urlpatterns += staticfiles_urlpatterns()

Visto il tipo di deploy, non lo vedo problematico, no?

#30 - 12/12/2016 12:24 PM - Enrico Zini

Uploadati backport di python-whitenoise e python3-whitenoise nel nostro repository reprepro.

#31 - 12/12/2016 12:27 PM - Christopher R. Gabriel

Messi anche nel repository FUSS, che e' quello che viene utilizzato

#32 - 12/12/2016 02:31 PM - Enrico Zini

Altra documentazione di riferimento:
https://code.djangoproject.com/wiki/SplitSettings

#33 - 12/12/2016 03:16 PM - Enrico Zini

- translation missing: en.field_checklist changed from [ ] Far servire i file statici a gunicorn3 to [x] Far servire i file statici a gunicorn3

#34 - 12/12/2016 03:50 PM - Enrico Zini

Fatto usando /etc/octonet.conf come altro nuovo settings.py. All'installazione, viene fatto girare il management command makesecret che genera un
SECRET_KEY nel file se non € ancora stato fatto.

#35 - 12/12/2016 03:58 PM - Anonymous
- Status changed from Commenti to Risolto

- % Done changed from 0 to 100

Applicata nel changeset dd99dbc0c86e581586385aaa7e3dcfffde63bal7.

#36 - 12/12/2016 03:59 PM - Enrico Zini

- Status changed from Risolto to Chiuso
